Loading...
Searching...
No Matches
elastix::ElastixBase Class Referenceabstract
Core » Kernel

`#include <elxElastixBase.h>`

## Detailed Description

This class creates an interface for elastix.

The ElastixBase class creates an interface for elastix. This is specified in ElastixTemplate, where all functions are defined. Functionality that does not depend on the pixel type and the dimension of the images to be registered, is defined in this class.

The parameters used by this class are:

Parameters
  RandomSeed: Sets a global seed for the random generator.
  example: (RandomSeed 121212)
  It must be a positive integer number. Default: 121212.

The command line arguments used by this class are:

Command line arguments

  -f: mandatory argument for elastix with the file name of the fixed image.
  example: -f fixedImage.mhd

  -m: mandatory argument for elastix with the file name of the moving image.
  example: -m movingImage.mhd

  -out: mandatory argument for both elastix and transformix with the name of the directory that is going to contain everything that elastix or tranformix returns as output.
  example: -out outputdirectory

  -p: mandatory argument for elastix with the name of the parameter file.
  example: -p parameters.txt
  Multiple parameter files are allowed. It means that multiple registrations are runned in sequence, with the output of some registration as input to the next.

  -fMask: Optional argument for elastix with the file name of a mask for the fixed image. The mask image should contain of zeros and ones, zeros indicating pixels that are not used for the registration.
  example: -fMask fixedmask.mhd

  -mMask: Optional argument for elastix with the file name of a mask for the moving image. The mask image should contain of zeros and ones, zeros indicating pixels that are not used for the registration.
  example: -mMask movingmask.mhd

  -tp: mandatory argument for transformix with the name of the transform parameter file.
  example: -tp TransformParameters.txt
  In one such a transform parameter file a reference can be used to another transform parameter file, which is then used as an initial transform.

  -priority: optional argument for both elastix and transformix to specify the priority setting of this process. Choose one from {belownormal, high}.
  example: -priority high
  This argument is only valid for running under Windows. For Linux, run elastix with "nice".

  -threads: optional argument for both elastix and transformix to specify the maximum number of threads used by this process. Default: no maximum.
  example: -threads 2

  -in: optional argument for transformix with the file name of an input image.
  example: -in inputImage.mhd
  If this option is skipped, a deformation field of the transform will be generated.

Definition at line 140 of file elxElastixBase.h.

Inheritance diagram for elastix::ElastixBase:
[legend]

## Data Structures

class | MultipleImageLoader

## Public Types

using | ComponentDatabasePointer = ComponentDatabase::Pointer
using | CoordRepType = double
using | DataObjectContainerPointer = DataObjectContainerType::Pointer
using | DataObjectContainerType = itk::VectorContainer<unsigned int, DataObjectPointer>
using | DataObjectPointer = itk::DataObject::Pointer
using | DBIndexType = ComponentDatabase::IndexType
using | FileNameContainerPointer = FileNameContainerType::Pointer
using | FileNameContainerType = itk::VectorContainer<unsigned int, std::string>
using | FlatDirectionCosinesType = std::vector<double>
using | ObjectContainerPointer = ObjectContainerType::Pointer
using | ObjectContainerType = itk::VectorContainer<unsigned int, ObjectPointer>
using | ObjectPointer = itk::Object::Pointer
using | ParameterMapType = itk::ParameterMapInterface::ParameterMapType
using | ResultDeformationFieldType = itk::DataObject
using | ResultImageType = itk::DataObject
using | Self = ElastixBase
using | Superclass = BaseComponent

## Public Member Functions

void | AddTargetCellToIterationInfo (const char *const name)
virtual int | ApplyTransform (bool doReadTransform)=0
int | BeforeAllBase () override
int | BeforeAllTransformixBase ()
virtual void | CreateTransformParameterMap ()=0
| elxGetNumberOfMacro (FixedImage)
| elxGetNumberOfMacro (FixedImageFileName)
| elxGetNumberOfMacro (FixedImagePyramid)
| elxGetNumberOfMacro (FixedMask)
| elxGetNumberOfMacro (FixedMaskFileName)
| elxGetNumberOfMacro (ImageSampler)
| elxGetNumberOfMacro (Interpolator)
| elxGetNumberOfMacro (Metric)
| elxGetNumberOfMacro (MovingImage)
| elxGetNumberOfMacro (MovingImageFileName)
| elxGetNumberOfMacro (MovingImagePyramid)
| elxGetNumberOfMacro (MovingMask)
| elxGetNumberOfMacro (MovingMaskFileName)
| elxGetNumberOfMacro (Optimizer)
| elxGetNumberOfMacro (Registration)
| elxGetNumberOfMacro (ResampleInterpolator)
| elxGetNumberOfMacro (Resampler)
| elxGetNumberOfMacro (ResultDeformationField)
| elxGetNumberOfMacro (ResultImage)
| elxGetNumberOfMacro (Transform)
| elxGetObjectMacro (Configuration, Configuration)
| elxGetObjectMacro (FinalTransform, itk::Object)
| elxGetObjectMacro (FixedImageContainer, DataObjectContainerType)
| elxGetObjectMacro (FixedImageFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (FixedImagePyramidContainer, ObjectContainerType)
| elxGetObjectMacro (FixedMaskContainer, DataObjectContainerType)
| elxGetObjectMacro (FixedMaskFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (ImageSamplerContainer, ObjectContainerType)
| elxGetObjectMacro (InitialTransform, itk::Object)
| elxGetObjectMacro (InterpolatorContainer, ObjectContainerType)
| elxGetObjectMacro (MetricContainer, ObjectContainerType)
| elxGetObjectMacro (MovingImageContainer, DataObjectContainerType)
| elxGetObjectMacro (MovingImageFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (MovingImagePyramidContainer, ObjectContainerType)
| elxGetObjectMacro (MovingMaskContainer, DataObjectContainerType)
| elxGetObjectMacro (MovingMaskFileNameContainer, FileNameContainerType)
| elxGetObjectMacro (OptimizerContainer, ObjectContainerType)
| elxGetObjectMacro (RegistrationContainer, ObjectContainerType)
| elxGetObjectMacro (ResampleInterpolatorContainer, ObjectContainerType)
| elxGetObjectMacro (ResamplerContainer, ObjectContainerType)
| elxGetObjectMacro (ResultDeformationFieldContainer, DataObjectContainerType)
| elxGetObjectMacro (ResultImageContainer, DataObjectContainerType)
| elxGetObjectMacro (TransformContainer, ObjectContainerType)
| elxSetObjectMacro (Configuration, Configuration)
| elxSetObjectMacro (FinalTransform, itk::Object)
| elxSetObjectMacro (FixedImageContainer, DataObjectContainerType)
| elxSetObjectMacro (FixedImageFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (FixedImagePyramidContainer, ObjectContainerType)
| elxSetObjectMacro (FixedMaskContainer, DataObjectContainerType)
| elxSetObjectMacro (FixedMaskFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (ImageSamplerContainer, ObjectContainerType)
| elxSetObjectMacro (InitialTransform, itk::Object)
| elxSetObjectMacro (InterpolatorContainer, ObjectContainerType)
| elxSetObjectMacro (MetricContainer, ObjectContainerType)
| elxSetObjectMacro (MovingImageContainer, DataObjectContainerType)
| elxSetObjectMacro (MovingImageFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (MovingImagePyramidContainer, ObjectContainerType)
| elxSetObjectMacro (MovingMaskContainer, DataObjectContainerType)
| elxSetObjectMacro (MovingMaskFileNameContainer, FileNameContainerType)
| elxSetObjectMacro (OptimizerContainer, ObjectContainerType)
| elxSetObjectMacro (RegistrationContainer, ObjectContainerType)
| elxSetObjectMacro (ResampleInterpolatorContainer, ObjectContainerType)
| elxSetObjectMacro (ResamplerContainer, ObjectContainerType)
| elxSetObjectMacro (ResultDeformationFieldContainer, DataObjectContainerType)
| elxSetObjectMacro (ResultImageContainer, DataObjectContainerType)
| elxSetObjectMacro (TransformContainer, ObjectContainerType)
DBIndexType | GetDBIndex ()
IterationInfo & | GetIterationInfo ()
std::ostream & | GetIterationInfoAt (const char *const name)
vcl_size_t | GetNumberOfTransformConfigurations () const
const FlatDirectionCosinesType & | GetOriginalFixedImageDirectionFlat () const
Configuration::ConstPointer | GetPreviousTransformConfiguration (const Configuration &configuration) const
ResultDeformationFieldType * | GetResultDeformationField (unsigned int idx=0) const
ResultImageType * | GetResultImage (const unsigned int idx=0) const
Configuration::ConstPointer | GetTransformConfiguration (const vcl_size_t index) const
ParameterMapType | GetTransformParameterMap () const
bool | GetUseDirectionCosines () const
| ITK_DISALLOW_COPY_AND_MOVE (ElastixBase)
virtual int | Run ()=0
void | SetDBIndex (DBIndexType _arg)
void | SetOriginalFixedImageDirectionFlat (const FlatDirectionCosinesType &arg)
void | SetResultDeformationField (DataObjectPointer result_deformationfield)
void | SetResultImage (DataObjectPointer result_image)
void | SetTransformConfigurations (const std::vector< Configuration::ConstPointer > &configurations)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIteration ()
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolution ()
virtual void | AfterEachResolutionBase ()
virtual void | AfterRegistration ()
virtual void | AfterRegistrationBase ()
virtual int | BeforeAll ()
virtual void | BeforeEachResolution ()
virtual void | BeforeEachResolutionBase ()
virtual void | BeforeRegistration ()
virtual void | BeforeRegistrationBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Protected Member Functions

| ElastixBase ()
| ~ElastixBase () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Static Protected Member Functions

static DataObjectContainerPointer | GenerateDataObjectContainer (DataObjectPointer dataObject)

## Protected Attributes

std::string | m_CurrentTransformParameterFileName
DBIndexType | m_DBIndex { 0 }
unsigned int | m_IterationCounter {}
std::ofstream | m_IterationInfoFile
itk::TimeProbe | m_IterationTimer {}
FlatDirectionCosinesType | m_OriginalFixedImageDirection
itk::TimeProbe | m_ResolutionTimer {}
itk::TimeProbe | m_Timer0 {}
ParameterMapType | m_TransformParameterMap

## Private Attributes

Configuration::Pointer | m_Configuration { nullptr }
ObjectPointer | m_FinalTransform { nullptr }
DataObjectContainerPointer | m_FixedImageContainer { DataObjectContainerType::New() }
FileNameContainerPointer | m_FixedImageFileNameContainer { FileNameContainerType::New() }
ObjectContainerPointer | m_FixedImagePyramidContainer { ObjectContainerType::New() }
DataObjectContainerPointer | m_FixedMaskContainer { DataObjectContainerType::New() }
FileNameContainerPointer | m_FixedMaskFileNameContainer { FileNameContainerType::New() }
ObjectContainerPointer | m_ImageSamplerContainer { ObjectContainerType::New() }
ObjectPointer | m_InitialTransform { nullptr }
ObjectContainerPointer | m_InterpolatorContainer { ObjectContainerType::New() }
IterationInfo | m_IterationInfo
ObjectContainerPointer | m_MetricContainer { ObjectContainerType::New() }
DataObjectContainerPointer | m_MovingImageContainer { DataObjectContainerType::New() }
FileNameContainerPointer | m_MovingImageFileNameContainer { FileNameContainerType::New() }
ObjectContainerPointer | m_MovingImagePyramidContainer { ObjectContainerType::New() }
DataObjectContainerPointer | m_MovingMaskContainer { DataObjectContainerType::New() }
FileNameContainerPointer | m_MovingMaskFileNameContainer { FileNameContainerType::New() }
ObjectContainerPointer | m_OptimizerContainer { ObjectContainerType::New() }
ObjectContainerPointer | m_RegistrationContainer { ObjectContainerType::New() }
ObjectContainerPointer | m_ResampleInterpolatorContainer { ObjectContainerType::New() }
ObjectContainerPointer | m_ResamplerContainer { ObjectContainerType::New() }
DataObjectContainerPointer | m_ResultDeformationFieldContainer
DataObjectContainerPointer | m_ResultImageContainer { DataObjectContainerType::New() }
std::vector< Configuration::ConstPointer > | m_TransformConfigurations
ObjectContainerPointer | m_TransformContainer { ObjectContainerType::New() }
bool | m_UseDirectionCosines { true }

## Additional Inherited Members

Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Member Typedef Documentation

## ComponentDatabasePointer

using elastix::ElastixBase::ComponentDatabasePointer = ComponentDatabase::Pointer

Other typedef's.

Definition at line 168 of file elxElastixBase.h.

## CoordRepType

using elastix::ElastixBase::CoordRepType = double

Type for representation of the transform coordinates.

Definition at line 173 of file elxElastixBase.h.

## DataObjectContainerPointer

using elastix::ElastixBase::DataObjectContainerPointer = DataObjectContainerType::Pointer

Definition at line 157 of file elxElastixBase.h.

## DataObjectContainerType

using elastix::ElastixBase::DataObjectContainerType = itk::VectorContainer<unsigned int, DataObjectPointer>

Definition at line 156 of file elxElastixBase.h.

## DataObjectPointer

using elastix::ElastixBase::DataObjectPointer = itk::DataObject::Pointer

Definition at line 153 of file elxElastixBase.h.

## DBIndexType

using elastix::ElastixBase::DBIndexType = ComponentDatabase::IndexType

Definition at line 169 of file elxElastixBase.h.

## FileNameContainerPointer

using elastix::ElastixBase::FileNameContainerPointer = FileNameContainerType::Pointer

Definition at line 159 of file elxElastixBase.h.

## FileNameContainerType

using elastix::ElastixBase::FileNameContainerType = itk::VectorContainer<unsigned int, std::string>

Definition at line 158 of file elxElastixBase.h.

## FlatDirectionCosinesType

using elastix::ElastixBase::FlatDirectionCosinesType = std::vector<double>

Definition at line 170 of file elxElastixBase.h.

## ObjectContainerPointer

using elastix::ElastixBase::ObjectContainerPointer = ObjectContainerType::Pointer

Definition at line 155 of file elxElastixBase.h.

## ObjectContainerType

using elastix::ElastixBase::ObjectContainerType = itk::VectorContainer<unsigned int, ObjectPointer>

Definition at line 154 of file elxElastixBase.h.

## ObjectPointer

using elastix::ElastixBase::ObjectPointer = itk::Object::Pointer

Typedefs used in this class.

Definition at line 152 of file elxElastixBase.h.

## ParameterMapType

using elastix::ElastixBase::ParameterMapType = itk::ParameterMapInterface::ParameterMapType

Typedef that is used in the elastix dll version.

Definition at line 176 of file elxElastixBase.h.

## ResultDeformationFieldType

using elastix::ElastixBase::ResultDeformationFieldType = itk::DataObject

Result deformation field

Definition at line 165 of file elxElastixBase.h.

## ResultImageType

using elastix::ElastixBase::ResultImageType = itk::DataObject

Result image

Definition at line 162 of file elxElastixBase.h.

## Self

using elastix::ElastixBase::Self = ElastixBase

Standard typedefs etc.

Definition at line 148 of file elxElastixBase.h.

## Superclass

using elastix::ElastixBase::Superclass = BaseComponent

Definition at line 149 of file elxElastixBase.h.

## Constructor & Destructor Documentation

## ElastixBase()

elastix::ElastixBase::ElastixBase | ( |  | ) |

protected

## ~ElastixBase()

elastix::ElastixBase::~ElastixBase | ( |  | ) |

override protected default

## Member Function Documentation

## AddTargetCellToIterationInfo()

void elastix::ElastixBase::AddTargetCellToIterationInfo | ( | const char *const | name | ) |

inline

Definition at line 381 of file elxElastixBase.h.

## ApplyTransform()

virtual int elastix::ElastixBase::ApplyTransform | ( | bool | doReadTransform | ) |

pure virtual

Empty ApplyTransform()-function to be overridden.

Implemented in elastix::ElastixTemplate< TFixedImage, TMovingImage >.

## BeforeAllBase()

int elastix::ElastixBase::BeforeAllBase | ( |  | ) |

override virtual

Function that is called at the very beginning of ElastixTemplate::Run(). It checks the command line input arguments.

Reimplemented from elastix::BaseComponent.

## BeforeAllTransformixBase()

int elastix::ElastixBase::BeforeAllTransformixBase | ( |  | ) |

Function that is called at the very beginning of ElastixTemplate::ApplyTransform(). It checks the command line input arguments.

## CreateTransformParameterMap()

virtual void elastix::ElastixBase::CreateTransformParameterMap | ( |  | ) |

pure virtual

Creates transformation parameters map.

Implemented in elastix::ElastixTemplate< TFixedImage, TMovingImage >.

## elxGetNumberOfMacro() [1/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | FixedImage |  | ) |

## elxGetNumberOfMacro() [2/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | FixedImageFileName |  | ) |

## elxGetNumberOfMacro() [3/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | FixedImagePyramid |  | ) |

## elxGetNumberOfMacro() [4/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | FixedMask |  | ) |

## elxGetNumberOfMacro() [5/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | FixedMaskFileName |  | ) |

## elxGetNumberOfMacro() [6/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | ImageSampler |  | ) |

## elxGetNumberOfMacro() [7/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | Interpolator |  | ) |

## elxGetNumberOfMacro() [8/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | Metric |  | ) |

## elxGetNumberOfMacro() [9/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | MovingImage |  | ) |

## elxGetNumberOfMacro() [10/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | MovingImageFileName |  | ) |

## elxGetNumberOfMacro() [11/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | MovingImagePyramid |  | ) |

## elxGetNumberOfMacro() [12/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | MovingMask |  | ) |

## elxGetNumberOfMacro() [13/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | MovingMaskFileName |  | ) |

## elxGetNumberOfMacro() [14/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | Optimizer |  | ) |

## elxGetNumberOfMacro() [15/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | Registration |  | ) |

Define some convenience functions: GetNumberOfMetrics() for example.

## elxGetNumberOfMacro() [16/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | ResampleInterpolator |  | ) |

## elxGetNumberOfMacro() [17/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | Resampler |  | ) |

## elxGetNumberOfMacro() [18/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | ResultDeformationField |  | ) |

## elxGetNumberOfMacro() [19/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | ResultImage |  | ) |

## elxGetNumberOfMacro() [20/20]

elastix::ElastixBase::elxGetNumberOfMacro | ( | Transform |  | ) |

## elxGetObjectMacro() [1/23]

elastix::ElastixBase::elxGetObjectMacro | ( | Configuration | ,
|  | Configuration | )

Set/Get the Configuration Object.

## elxGetObjectMacro() [2/23]

elastix::ElastixBase::elxGetObjectMacro | ( | FinalTransform | ,
|  | itk::Object | )

## elxGetObjectMacro() [3/23]

elastix::ElastixBase::elxGetObjectMacro | ( | FixedImageContainer | ,
|  | DataObjectContainerType | )

Set/Get the fixed/moving image containers.

## elxGetObjectMacro() [4/23]

elastix::ElastixBase::elxGetObjectMacro | ( | FixedImageFileNameContainer | ,
|  | FileNameContainerType | )

Set/Get The Image FileName containers. Normally, these are filled in the BeforeAllBase function.

## elxGetObjectMacro() [5/23]

elastix::ElastixBase::elxGetObjectMacro | ( | FixedImagePyramidContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [6/23]

elastix::ElastixBase::elxGetObjectMacro | ( | FixedMaskContainer | ,
|  | DataObjectContainerType | )

Set/Get the fixed/moving mask containers.

## elxGetObjectMacro() [7/23]

elastix::ElastixBase::elxGetObjectMacro | ( | FixedMaskFileNameContainer | ,
|  | FileNameContainerType | )

Set/Get The Mask FileName containers. Normally, these are filled in the BeforeAllBase function.

## elxGetObjectMacro() [8/23]

elastix::ElastixBase::elxGetObjectMacro | ( | ImageSamplerContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [9/23]

elastix::ElastixBase::elxGetObjectMacro | ( | InitialTransform | ,
|  | itk::Object | )

## elxGetObjectMacro() [10/23]

elastix::ElastixBase::elxGetObjectMacro | ( | InterpolatorContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [11/23]

elastix::ElastixBase::elxGetObjectMacro | ( | MetricContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [12/23]

elastix::ElastixBase::elxGetObjectMacro | ( | MovingImageContainer | ,
|  | DataObjectContainerType | )

## elxGetObjectMacro() [13/23]

elastix::ElastixBase::elxGetObjectMacro | ( | MovingImageFileNameContainer | ,
|  | FileNameContainerType | )

## elxGetObjectMacro() [14/23]

elastix::ElastixBase::elxGetObjectMacro | ( | MovingImagePyramidContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [15/23]

elastix::ElastixBase::elxGetObjectMacro | ( | MovingMaskContainer | ,
|  | DataObjectContainerType | )

## elxGetObjectMacro() [16/23]

elastix::ElastixBase::elxGetObjectMacro | ( | MovingMaskFileNameContainer | ,
|  | FileNameContainerType | )

## elxGetObjectMacro() [17/23]

elastix::ElastixBase::elxGetObjectMacro | ( | OptimizerContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [18/23]

elastix::ElastixBase::elxGetObjectMacro | ( | RegistrationContainer | ,
|  | ObjectContainerType | )

Get the component containers. The component containers store components, such as the metric, in the form of an itk::Object::Pointer.

## elxGetObjectMacro() [19/23]

elastix::ElastixBase::elxGetObjectMacro | ( | ResampleInterpolatorContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [20/23]

elastix::ElastixBase::elxGetObjectMacro | ( | ResamplerContainer | ,
|  | ObjectContainerType | )

## elxGetObjectMacro() [21/23]

elastix::ElastixBase::elxGetObjectMacro | ( | ResultDeformationFieldContainer | ,
|  | DataObjectContainerType | )

Set/Get the result image container.

## elxGetObjectMacro() [22/23]

elastix::ElastixBase::elxGetObjectMacro | ( | ResultImageContainer | ,
|  | DataObjectContainerType | )

Set/Get the result image container.

## elxGetObjectMacro() [23/23]

elastix::ElastixBase::elxGetObjectMacro | ( | TransformContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [1/23]

elastix::ElastixBase::elxSetObjectMacro | ( | Configuration | ,
|  | Configuration | )

## elxSetObjectMacro() [2/23]

elastix::ElastixBase::elxSetObjectMacro | ( | FinalTransform | ,
|  | itk::Object | )

Set/Get the final transform The type is itk::Object, but the pointer should actually point to an itk::Transform type (or inherited from that one). You can use this to set it as an initial transform in another ElastixBase instantiation.

## elxSetObjectMacro() [3/23]

elastix::ElastixBase::elxSetObjectMacro | ( | FixedImageContainer | ,
|  | DataObjectContainerType | )

## elxSetObjectMacro() [4/23]

elastix::ElastixBase::elxSetObjectMacro | ( | FixedImageFileNameContainer | ,
|  | FileNameContainerType | )

## elxSetObjectMacro() [5/23]

elastix::ElastixBase::elxSetObjectMacro | ( | FixedImagePyramidContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [6/23]

elastix::ElastixBase::elxSetObjectMacro | ( | FixedMaskContainer | ,
|  | DataObjectContainerType | )

## elxSetObjectMacro() [7/23]

elastix::ElastixBase::elxSetObjectMacro | ( | FixedMaskFileNameContainer | ,
|  | FileNameContainerType | )

## elxSetObjectMacro() [8/23]

elastix::ElastixBase::elxSetObjectMacro | ( | ImageSamplerContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [9/23]

elastix::ElastixBase::elxSetObjectMacro | ( | InitialTransform | ,
|  | itk::Object | )

Set/Get the initial transform The type is itk::Object, but the pointer should actually point to an itk::Transform type (or inherited from that one).

## elxSetObjectMacro() [10/23]

elastix::ElastixBase::elxSetObjectMacro | ( | InterpolatorContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [11/23]

elastix::ElastixBase::elxSetObjectMacro | ( | MetricContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [12/23]

elastix::ElastixBase::elxSetObjectMacro | ( | MovingImageContainer | ,
|  | DataObjectContainerType | )

## elxSetObjectMacro() [13/23]

elastix::ElastixBase::elxSetObjectMacro | ( | MovingImageFileNameContainer | ,
|  | FileNameContainerType | )

## elxSetObjectMacro() [14/23]

elastix::ElastixBase::elxSetObjectMacro | ( | MovingImagePyramidContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [15/23]

elastix::ElastixBase::elxSetObjectMacro | ( | MovingMaskContainer | ,
|  | DataObjectContainerType | )

## elxSetObjectMacro() [16/23]

elastix::ElastixBase::elxSetObjectMacro | ( | MovingMaskFileNameContainer | ,
|  | FileNameContainerType | )

## elxSetObjectMacro() [17/23]

elastix::ElastixBase::elxSetObjectMacro | ( | OptimizerContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [18/23]

elastix::ElastixBase::elxSetObjectMacro | ( | RegistrationContainer | ,
|  | ObjectContainerType | )

Set the component containers. The component containers store components, such as the metric, in the form of an itk::Object::Pointer.

## elxSetObjectMacro() [19/23]

elastix::ElastixBase::elxSetObjectMacro | ( | ResampleInterpolatorContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [20/23]

elastix::ElastixBase::elxSetObjectMacro | ( | ResamplerContainer | ,
|  | ObjectContainerType | )

## elxSetObjectMacro() [21/23]

elastix::ElastixBase::elxSetObjectMacro | ( | ResultDeformationFieldContainer | ,
|  | DataObjectContainerType | )

## elxSetObjectMacro() [22/23]

elastix::ElastixBase::elxSetObjectMacro | ( | ResultImageContainer | ,
|  | DataObjectContainerType | )

## elxSetObjectMacro() [23/23]

elastix::ElastixBase::elxSetObjectMacro | ( | TransformContainer | ,
|  | ObjectContainerType | )

## GenerateDataObjectContainer()

DataObjectContainerPointer elastix::ElastixBase::GenerateDataObjectContainer | ( | DataObjectPointer | dataObject | ) |

static protected

Generates a container that contains the specified data object

## GetDBIndex()

DBIndexType elastix::ElastixBase::GetDBIndex | ( |  | ) |

inline

Definition at line 187 of file elxElastixBase.h.

## GetIterationInfo()

IterationInfo & elastix::ElastixBase::GetIterationInfo | ( |  | ) |

inline

Definition at line 369 of file elxElastixBase.h.

## GetIterationInfoAt()

std::ostream & elastix::ElastixBase::GetIterationInfoAt | ( | const char *const | name | ) |

inline

Definition at line 375 of file elxElastixBase.h.

## GetNumberOfTransformConfigurations()

vcl_size_t elastix::ElastixBase::GetNumberOfTransformConfigurations | ( |  | ) | const

Returns the number of configurations in the vector of transformation configurations.

## GetOriginalFixedImageDirectionFlat()

const FlatDirectionCosinesType & elastix::ElastixBase::GetOriginalFixedImageDirectionFlat | ( |  | ) | const

## GetPreviousTransformConfiguration()

Configuration::ConstPointer elastix::ElastixBase::GetPreviousTransformConfiguration | ( | const Configuration & | configuration | ) | const

Returns the transformation configuration just before the specified one, or null. Returns null if the specified configuration does not have a previous one in the vector of transformation configurations.

## GetResultDeformationField()

ResultDeformationFieldType * elastix::ElastixBase::GetResultDeformationField | ( | unsigned int | idx = 0 | ) | const

## GetResultImage()

ResultImageType * elastix::ElastixBase::GetResultImage | ( | const unsigned int | idx = 0 | ) | const

## GetTransformConfiguration()

Configuration::ConstPointer elastix::ElastixBase::GetTransformConfiguration | ( | const vcl_size_t | index | ) | const

Return configuration from vector of transformation configurations. Library only.

## GetTransformParameterMap()

ParameterMapType elastix::ElastixBase::GetTransformParameterMap | ( |  | ) | const

Gets transformation parameters map.

## GetUseDirectionCosines()

bool elastix::ElastixBase::GetUseDirectionCosines | ( |  | ) | const

Get whether direction cosines should be taken into account (true) or ignored (false). This depends on the UseDirectionCosines parameter.

## ITK_DISALLOW_COPY_AND_MOVE()

elastix::ElastixBase::ITK_DISALLOW_COPY_AND_MOVE | ( | ElastixBase |  | ) |

## Run()

virtual int elastix::ElastixBase::Run | ( |  | ) |

pure virtual

Empty Run()-function to be overridden.

Implemented in elastix::ElastixTemplate< TFixedImage, TMovingImage >.

## SetDBIndex()

void elastix::ElastixBase::SetDBIndex | ( | DBIndexType | _arg | ) |

Set the database index of the instantiated elastix object.

## SetOriginalFixedImageDirectionFlat()

void elastix::ElastixBase::SetOriginalFixedImageDirectionFlat | ( | const FlatDirectionCosinesType & | arg | ) |

Set/Get the original fixed image direction as a flat array (d11 d21 d31 d21 d22 etc )

## SetResultDeformationField()

void elastix::ElastixBase::SetResultDeformationField | ( | DataObjectPointer | result_deformationfield | ) |

## SetResultImage()

void elastix::ElastixBase::SetResultImage | ( | DataObjectPointer | result_image | ) |

## SetTransformConfigurations()

void elastix::ElastixBase::SetTransformConfigurations | ( | const std::vector< Configuration::ConstPointer > & | configurations | ) |

Set configuration vector. Library only.

## Field Documentation

## m_Configuration

Configuration::Pointer elastix::ElastixBase::m_Configuration { nullptr }

private

Definition at line 486 of file elxElastixBase.h.

## m_CurrentTransformParameterFileName

std::string elastix::ElastixBase::m_CurrentTransformParameterFileName

protected

Store the CurrentTransformParameterFileName.

Definition at line 400 of file elxElastixBase.h.

## m_DBIndex

DBIndexType elastix::ElastixBase::m_DBIndex { 0 }

protected

Definition at line 390 of file elxElastixBase.h.

## m_FinalTransform

ObjectPointer elastix::ElastixBase::m_FinalTransform { nullptr }

private

Definition at line 527 of file elxElastixBase.h.

## m_FixedImageContainer

DataObjectContainerPointer elastix::ElastixBase::m_FixedImageContainer { DataObjectContainerType::New() }

private

The Image and Mask containers. These are stored as pointers to itk::DataObject.

Definition at line 508 of file elxElastixBase.h.

## m_FixedImageFileNameContainer

FileNameContainerPointer elastix::ElastixBase::m_FixedImageFileNameContainer { FileNameContainerType::New() }

private

The image and mask FileNameContainers.

Definition at line 520 of file elxElastixBase.h.

## m_FixedImagePyramidContainer

ObjectContainerPointer elastix::ElastixBase::m_FixedImagePyramidContainer { ObjectContainerType::New() }

private

The component containers. These containers contain SmartPointer's to itk::Object.

Definition at line 496 of file elxElastixBase.h.

## m_FixedMaskContainer

DataObjectContainerPointer elastix::ElastixBase::m_FixedMaskContainer { DataObjectContainerType::New() }

private

Definition at line 510 of file elxElastixBase.h.

## m_FixedMaskFileNameContainer

FileNameContainerPointer elastix::ElastixBase::m_FixedMaskFileNameContainer { FileNameContainerType::New() }

private

Definition at line 522 of file elxElastixBase.h.

## m_ImageSamplerContainer

ObjectContainerPointer elastix::ElastixBase::m_ImageSamplerContainer { ObjectContainerType::New() }

private

Definition at line 499 of file elxElastixBase.h.

## m_InitialTransform

ObjectPointer elastix::ElastixBase::m_InitialTransform { nullptr }

private

The initial and final transform.

Definition at line 526 of file elxElastixBase.h.

## m_InterpolatorContainer

ObjectContainerPointer elastix::ElastixBase::m_InterpolatorContainer { ObjectContainerType::New() }

private

Definition at line 498 of file elxElastixBase.h.

## m_IterationCounter

unsigned int elastix::ElastixBase::m_IterationCounter {}

protected

Count the number of iterations.

Definition at line 403 of file elxElastixBase.h.

## m_IterationInfo

IterationInfo elastix::ElastixBase::m_IterationInfo

private

Definition at line 491 of file elxElastixBase.h.

## m_IterationInfoFile

std::ofstream elastix::ElastixBase::m_IterationInfoFile

protected

Definition at line 408 of file elxElastixBase.h.

## m_IterationTimer

itk::TimeProbe elastix::ElastixBase::m_IterationTimer {}

protected

Definition at line 396 of file elxElastixBase.h.

## m_MetricContainer

ObjectContainerPointer elastix::ElastixBase::m_MetricContainer { ObjectContainerType::New() }

private

Definition at line 500 of file elxElastixBase.h.

## m_MovingImageContainer

DataObjectContainerPointer elastix::ElastixBase::m_MovingImageContainer { DataObjectContainerType::New() }

private

Definition at line 509 of file elxElastixBase.h.

## m_MovingImageFileNameContainer

FileNameContainerPointer elastix::ElastixBase::m_MovingImageFileNameContainer { FileNameContainerType::New() }

private

Definition at line 521 of file elxElastixBase.h.

## m_MovingImagePyramidContainer

ObjectContainerPointer elastix::ElastixBase::m_MovingImagePyramidContainer { ObjectContainerType::New() }

private

Definition at line 497 of file elxElastixBase.h.

## m_MovingMaskContainer

DataObjectContainerPointer elastix::ElastixBase::m_MovingMaskContainer { DataObjectContainerType::New() }

private

Definition at line 511 of file elxElastixBase.h.

## m_MovingMaskFileNameContainer

FileNameContainerPointer elastix::ElastixBase::m_MovingMaskFileNameContainer { FileNameContainerType::New() }

private

Definition at line 523 of file elxElastixBase.h.

## m_OptimizerContainer

ObjectContainerPointer elastix::ElastixBase::m_OptimizerContainer { ObjectContainerType::New() }

private

Definition at line 501 of file elxElastixBase.h.

## m_OriginalFixedImageDirection

FlatDirectionCosinesType elastix::ElastixBase::m_OriginalFixedImageDirection

protected

Definition at line 392 of file elxElastixBase.h.

## m_RegistrationContainer

ObjectContainerPointer elastix::ElastixBase::m_RegistrationContainer { ObjectContainerType::New() }

private

Definition at line 502 of file elxElastixBase.h.

## m_ResampleInterpolatorContainer

ObjectContainerPointer elastix::ElastixBase::m_ResampleInterpolatorContainer { ObjectContainerType::New() }

private

Definition at line 504 of file elxElastixBase.h.

## m_ResamplerContainer

ObjectContainerPointer elastix::ElastixBase::m_ResamplerContainer { ObjectContainerType::New() }

private

Definition at line 503 of file elxElastixBase.h.

## m_ResolutionTimer

itk::TimeProbe elastix::ElastixBase::m_ResolutionTimer {}

protected

Definition at line 397 of file elxElastixBase.h.

## m_ResultDeformationFieldContainer

DataObjectContainerPointer elastix::ElastixBase::m_ResultDeformationFieldContainer

private

The result deformation field container. These are stored as pointers to itk::DataObject.

Definition at line 517 of file elxElastixBase.h.

## m_ResultImageContainer

DataObjectContainerPointer elastix::ElastixBase::m_ResultImageContainer { DataObjectContainerType::New() }

private

The result image container. These are stored as pointers to itk::DataObject.

Definition at line 514 of file elxElastixBase.h.

## m_Timer0

itk::TimeProbe elastix::ElastixBase::m_Timer0 {}

protected

Timers.

Definition at line 395 of file elxElastixBase.h.

## m_TransformConfigurations

std::vector<Configuration::ConstPointer> elastix::ElastixBase::m_TransformConfigurations

private

A vector of configuration objects, needed when transformix is used as library.

Definition at line 489 of file elxElastixBase.h.

## m_TransformContainer

ObjectContainerPointer elastix::ElastixBase::m_TransformContainer { ObjectContainerType::New() }

private

Definition at line 505 of file elxElastixBase.h.

## m_TransformParameterMap

ParameterMapType elastix::ElastixBase::m_TransformParameterMap

protected

Stores transformation parameters map.

Definition at line 406 of file elxElastixBase.h.

## m_UseDirectionCosines

bool elastix::ElastixBase::m_UseDirectionCosines { true }

private

Use or ignore direction cosines. From Elastix 4.3 to 4.7: Ignore direction cosines by default, for backward compatability. From Elastix 4.8: set it to true by default.

Definition at line 532 of file elxElastixBase.h.

Generated on 1768596610 for elastix by 1.15.0 |